 /*
  * Khoros: $Id$
  */

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: #defines and #includes for the
   >>>>		       axis object class.
   >>>>
   >>>>    Written By: Danielle Argiro, John Salas, Mark Young
   >>>>
   >>>>          Date: Aug 20, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_Axis_h_
#define _xvisual_Axis_h_

	/*-------------------------------------*
	|       #includes 
	---------------------------------------*/

/*
 *  too many axis class attributes to list here; they are divided
 *  among the following Axis*.h files.
 */
#include <xvisual/AxisGeneral.h>
#include <xvisual/AxisElements.h>
#include <xvisual/AxisLabel.h>
#include <xvisual/AxisLines.h>
#include <xvisual/AxisColor.h>


	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/
/*
 *  Value definitions for Axis Visual Object
 */
#define KAXIS_SET_LABELED_INTERVAL    1
#define KAXIS_SET_NUMBER_STEPS        2
#define KAXIS_SET_INTERVAL_STEPS      3
#define KAXIS_SET_MAX_MIN             4
#define KAXIS_SET_DEFAULT_MODE        5

#define KAXIS_INSIDE                  1
#define KAXIS_CENTERED                2
#define KAXIS_OUTSIDE                 3

#define KAXIS_LINEAR 1
#define KAXIS_LOG    2

/*
 *  Define the Class name, by which people should be externally referencing
 *  the Axis Object by.
 */
#define AxisGadgetClass	xvwAxisGadgetClass

    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit WidgetClass Declaration AxisGadgetClass
 */
extern   WidgetClass	AxisGadgetClass;


#endif /* _xvisual_Axis_h_ */
/* Don't add after this point */
